/*****************************************************************************
 * Axel
 *****************************************************************************
 * QConstraintANGLE
 * 2007-01-13
 * Arnaud Fabre
 *****************************************************************************
 *               Copyright (C) 2007 INRIA Sophia-Antipolis
 *               Copyright (C) 2007 LSIIT - UMR CNRS-ULP - Strasbourg
 *****************************************************************************
 * Comments :
 ****************************************************************************/

# ifndef QCONSTRAINTANGLE_H
# define QCONSTRAINTANGLE_H

# include <QAxel/QConstraint.h>

namespace QAxel 
{

/****************************************************************************/
/*!
  \class QConstraintAngle QConstraintAngle.h
  \brief The class QConstraintAngle provides an angle constraint.

  More ...
*/
/****************************************************************************/
class QConstraintAngle : public QConstraint
{
	Q_OBJECT
	Q_PROPERTY(float value READ getValue WRITE setValue)

public :
	QConstraintAngle(QAxelObject *o1, QAxelObject *o2, float value);
	~QConstraintAngle(void);
	
	void draw(void);
	void drawWithNames(void);
	
	static GLUquadricObj *quadObj;
	
	/**
	 * Compute the angle between two QAxelObjects in the sketch.
	 */
	float computeAngle(void);
	
	/**
	 * Accessors
	 */
	float getValue() const;
	void setValue(float f);
	
private :
	float _value;
	static int id_;
};

} // namespace QAxel

# endif
