/*****************************************************************************
 * Axel
 *****************************************************************************
 * ImplicitSurface.h
 * 2007-05-22
 * Julien Wintz
 *****************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :
 *
 ****************************************************************************/

# ifndef QIMPLICITSURFACE_H
# define QIMPLICITSURFACE_H

# include <QAxel/QSurface.h>
# include <QAxel/QSingularity.h>

namespace QAxel {

class QBoundingBox ;

/****************************************************************************/
/*!
  \class QImplicitSurface QSurface.h
  \brief The class QImplicitSurface provides ...

  More ...
*/
/****************************************************************************/
class QImplicitSurface : public QSurface 
{
    Q_OBJECT
    
public:
    QImplicitSurface(QString equation, QBoundingBox * boundingbox) ;
    QImplicitSurface(QString equation, 
		     double xmin = -2.001, double xmax = 2.001, 
		     double ymin = -2.001, double ymax = 2.001, 
		     double zmin = -2.001, double zmax = 2.001) ;
    
    void draw(void) ;
    void drawWithNames(void) ;
	
public slots:
    QString equation(void) ;
    void setEquation(QString equation) { equation_ = equation ; }
	
    int nbSingularities(void) { return singularities.size() ; }
    bool singularitiesDrawn(void) { return draw_singularities ; }
    void setSingularitiesDrawn(bool b) { draw_singularities = b ; }
    void push_singularity(QSingularity * sing) { singularities.push_back(sing) ; }
    
    QAxelObject * toObject(void) { return (QAxelObject *)this ; }
	
private:
    QString equation_ ;
    bool draw_singularities ;
    QList<QSingularity *> singularities ;

private:
    static int id_ ;
} ;

} ;

# endif
