/*****************************************************************************
 * P o l y n o m
 *****************************************************************************
 * QMeshFactory
 * 2006-03-29
 * Julien Wintz
 *****************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :         
 *
 ****************************************************************************/

# ifndef QMESHFACTORY_H
# define QMESHFACTORY_H

namespace QAxel {

class QMesh ;

/****************************************************************************/
/*!
  \class QMeshFactory QMeshFactory.h
  \brief The class QMeshFactory provides ...

  More ...
*/
/****************************************************************************/
class QMeshFactory 
{
public :
	QMesh * createPlaneMesh(void) ;
	QMesh * createCubeMesh(void) ;
	QMesh * createSphereMesh(void) ;
	QMesh * createConeMesh(void) ;
	QMesh * createCylinderMesh(void) ;
	QMesh * createTubeMesh(void) ;
	
	static QMeshFactory * instance(void) {
		return m_Instance ;
	}

private:
	static QMeshFactory * m_Instance ;
} ;

} ;

# endif
