/*****************************************************************************
 * Axel
 *****************************************************************************
 * Curves in Axel
 * 2007-05-22
 * Ashish Reddy
 *****************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :
 *
 ****************************************************************************/

# ifndef QPARAMETRICCURVE_H
# define QPARAMETRICCURVE_H

# include <QAxel/QCurve.h>

namespace QAxel {

class QBoundingBox;
class QPoint3f ;

/****************************************************************************/
/*!
  \class QParametricCurve QCurve.h
  \brief The class QParametricCurve is an abstract class for...

  More ...
*/
/****************************************************************************/
class QParametricCurve : public QCurve 
{
	Q_OBJECT

public:
    QParametricCurve(void) : QCurve() {} ;
    QParametricCurve(QBoundingBox * boundingbox) : QCurve(boundingbox) {} ;
    QParametricCurve(double xmin, double xmax, 
		     double ymin, double ymax, 
		     double zmin = 0, double zmax = 0) : QCurve(xmin, xmax, 
								ymin, ymax, 
								zmin, zmax) {} ;
									       
public slots:
    virtual float umin(void) = 0 ;
    virtual float umax(void) = 0 ;
    virtual QPoint3f * eval(float u) = 0 ;
} ;

} ; // namespace QAxel ;

# endif // QPARAMETRICCURVE_H
