/*****************************************************************************
 * Axel
 *****************************************************************************
 * QPiecewiseLinearSurface
 * 2007-05-20
 * Julien Wintz
 *****************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :
 *
 ****************************************************************************/

# include <QAxel/QDisplayList.h>
# include <QAxel/QPiecewiseLinearSurface.h>

namespace QAxel {

QPiecewiseLinearSurface::QPiecewiseLinearSurface(void) : QSurface()
{
    QString str ;
    setProperty("type", "PiecewiseLinearSurfqce") ;
    setProperty("name", "plsurface_"+str.setNum(id_)) ;
}

QPiecewiseLinearSurface::QPiecewiseLinearSurface(QBoundingBox * bb) : QSurface(bb)
{
    QString str ;
    setProperty("type", "PiecewiseLinearSurfqce") ;
    setProperty("name", "plsurface_"+str.setNum(id_)) ;
}

QPiecewiseLinearSurface::QPiecewiseLinearSurface(double xmin, double xmax, 
						 double ymin, double ymax,
						 double zmin, double zmax) : QSurface(xmin, xmax,
										      ymin, ymax,
										      zmin, zmax)
{
    QString str ;
    setProperty("type", "PiecewiseLinearSurface") ;
    setProperty("name", "plsurface_"+str.setNum(id_)) ;
}

QPiecewiseLinearSurface::~QPiecewiseLinearSurface(void)
{

}

void QPiecewiseLinearSurface::draw(void)
{
    if(s_dirty || !s_dlist->isValid()) {
	s_dlist->begin() ;
	// Drawing code here
	s_dlist->end() ;
    }
    s_dlist->draw() ;    
}

void QPiecewiseLinearSurface::drawWithNames(void)
{
    glPushName((GLuint)this) ;
    draw();
    glPopName() ;
}

void QPiecewiseLinearSurface::sort(void)
{
    
}

bool QPiecewiseLinearSurface::closed(void)
{

}

bool QPiecewiseLinearSurface::opened(void)
{

}

int QPiecewiseLinearSurface::id_ = 0 ;

} ; // namespace QAxel
