/*****************************************************************************
 * Axel
 *****************************************************************************
 * QRationalCurve
 * 2007-05-22
 * Julien Wintz
 * Ashish Reddy
 *****************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :
 *
 ****************************************************************************/

# ifndef QRATIONALCURVE_H
# define QRATIONALCURVE_H

# include <QAxel/QParametricCurve.h>

namespace QAxel {

class QBoundingBox ;

/****************************************************************************/
/*!
  \class QRationalCurve QCurve.h
  \brief The class QRationalCurve provides...

  More ...
*/
/****************************************************************************/
class QRationalCurve : public QParametricCurve 
{
    Q_OBJECT

public :
    QRationalCurve(QString px, QString py, QString pz, QString pw,
		   double tmin = 0.0, double tmax = 0.0, 
		   QBoundingBox * boundingbox = NULL) ;
    
    void compute(void) ;
    void draw(void) ;
    void drawWithNames(void) ;
    
public slots:
    QString px(void) { return px_ ; }
    QString py(void) { return py_ ; }
    QString pz(void) { return pz_ ; }
    QString pw(void) { return pw_ ; }

    QPoint3f * eval(float u) ;
    float umin(void) { return tmin_ ; }
    float umax(void) { return tmax_ ; }
    
    double tmin(void) { return tmin_ ; }
    double tmax(void) { return tmax_ ; }
    
    void setTMin(double t) { tmin_ = t ; }
    void setTMax(double t) { tmax_ = t ; }

    QAxelObject * toObject(void) { return (QAxelObject *)this ; }
    
private :
    QString px_ ;
    QString py_ ;
    QString pz_ ;
    QString pw_ ;
    
    double tmin_ ;
    double tmax_ ;
    
    static int id_ ;
} ;

} ;

# endif 
