/*****************************************************************************
 * A x e l
 *****************************************************************************
 * QCoreInterface
 * 2006-11-06
 * Julien Wintz
 *****************************************************************************
 *               Copyright (C) 2006-2007 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :         
 *
 ****************************************************************************/

# ifndef QCOREINTERFACE_H
# define QCOREINTERFACE_H

# include <QObject>
# include <QStringList>

# include <QAxel/QInitializablePluginInterface.h>
# include <QAxel/QShape.h>
# include <QAxel/QRationalCurve.h>
# include <QAxel/QBSplineCurve.h>
# include <QAxel/QNurbsCurve.h>
# include <QAxel/QImplicitCurve2D.h>
# include <QAxel/QImplicitCurve3D.h>
# include <QAxel/QImplicitCurve4D.h>
# include <QAxel/QRationalSurface.h>
# include <QAxel/QBSplineSurface.h>
# include <QAxel/QNurbsSurface.h>
# include <QAxel/QImplicitSurface.h>


/****************************************************************************/
/*!
  \class QCoreInterface QCoreInterface.h
  \brief The class QCoreInterface provides ...

  More ...
*/
/****************************************************************************/
class QCoreInterface : public QAxel::QInitializablePluginInterface
{
public :
    typedef QAxel::QAxelObject QAxelObject;

    virtual ~QCoreInterface() {}

    virtual void create(QAxel::QRationalCurve * c) = 0 ;
    virtual void create(QAxel::QRationalSurface * s) = 0 ;
    virtual void create(QAxel::QBSplineCurve * c) = 0 ;
    virtual void create(QAxel::QBSplineSurface * s) = 0 ;

    virtual QAxel::QPoint3f * eval(QAxel::QRationalCurve * c, float u) = 0 ;
    virtual QAxel::QPoint3f * eval(QAxel::QRationalSurface * s, float u, float v) = 0 ;
    virtual QAxel::QPoint3f * eval(QAxel::QBSplineCurve * c, float u) = 0 ;
    virtual QAxel::QPoint3f * eval(QAxel::QBSplineSurface * s, float u, float v) = 0 ;

    virtual QAxel::QShape * intersect(QAxelObject * s1, QAxelObject * s2) = 0 ;
    virtual QAxel::QShape * autointersect(QAxelObject * s) = 0 ;
    
    virtual void draw(QAxelObject * o) = 0 ;

    virtual void getGlData(QAxel::QBSplineSurface * s, int * nbi, int * indices, int * nbv, double * vertices) = 0 ;
} ;

Q_DECLARE_INTERFACE(QCoreInterface, "Axel::Interfaces::Core/0.11")

# endif
