/*****************************************************************************
 * A x e l
 *****************************************************************************
 * QGraphEdge
 * 2006-10-04
 * Julien Wintz
 *****************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :
 ****************************************************************************/
 
# ifndef QGRAPHEDGE_H
# define QGRAPHEDGE_H

# include <QString>
# include <QList>

namespace QData {

class QGraphNode ;

/****************************************************************************/
/*!
  \class QGraphEdge QGraphEdge.h
  \brief The class QGraphEdge provides ...

  More ...
*/
/****************************************************************************/
class QGraphEdge 
{
public:
	QGraphEdge(QGraphNode *sourceNode, QGraphNode *destNode) ;
	~QGraphEdge(void) ;

	QString label(void) ;

	QGraphNode *sourceNode() const;
	void setSourceNode(QGraphNode *node);

	QGraphNode *destNode() const;
	void setDestNode(QGraphNode *node);
	
	QList<QGraphNode *> adjacentNodes(void) ;

private:
	QString label_ ;
	QGraphNode * source ;
	QGraphNode * dest ;
} ;	

} ; // namespace QData

# endif // QGRAPHEDGE_H
