/*****************************************************************************
> * A x e l
 *****************************************************************************
 * QOctree
 * 2007-04-06
 * Julien Wintz
 *****************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :
 ****************************************************************************/

# ifndef QOCTREE_H
# define QOCTREE_H

# include <QData/QTreeNode.h>

namespace QData {

/****************************************************************************/
/*!
  \class QOctree QOctree.h
  \brief ....
*/
/****************************************************************************/

template <class Object, class Cell> class QOctree
{
public:
    
    // The root node.
    QTreeNode<Object, Cell>* root;
    
    // Constructor with initialization.
    QOctree<Object, Cell>() {
	root = new QTreeNode<Object, Cell>();
	root->SetParent(NULL);
    } 
    
    // Accessor.
    QTreeNode<Object, Cell>* GetRoot() { return(root); }
    
    QGraph * toGraph(void) {
	QGraph * graph = new QGraph ;
	graph->setType(QGraph::Octree) ;
	addNode(graph, root, NULL) ;
	return graph ;
    }
    
    void addNode(QGraph * graph, QTreeNode<Object, Cell> * node, QGraphNode * parent) {
	QGraphNode * n = new QGraphNode("", node->GetCell()) ;
	n->setColors(Qt::blue, Qt::darkBlue) ;
	graph->addNode(n) ;
	
	if(parent) {
	    QGraphEdge * e = new QGraphEdge(parent, n) ;
	    graph->addEdge(e) ;
	}
	
	if(node->GetF_NWchild()) addNode(graph, node->GetF_NWchild(), n) ;
	if(node->GetF_NEchild()) addNode(graph, node->GetF_NEchild(), n) ;
	if(node->GetF_SWchild()) addNode(graph, node->GetF_SWchild(), n) ;
	if(node->GetF_SEchild()) addNode(graph, node->GetF_SEchild(), n) ;
    }
} ;

# include "QOctree.cpp"

} ; // namespace QData

# endif
