/******************************************************************************
 * A x e l                                                                    *
 ******************************************************************************
 * QRegionVertex                                                              *
 * 2006-10-16                                                                 *
 * Julien Wintz                                                               *
 ******************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis                    *
 ******************************************************************************
 * Comments :                                                                 *
 ******************************************************************************/

# include <QData/QRegionVertex.h>
# include <QData/QRegionEdge.h>

namespace QData {

int QRegionVertex::id_ = 0 ;

QRegionVertex::QRegionVertex(float x, float y) : QPoint3f(x, y, 0.0) 
{
	QString str ;
	setProperty("type", "RegionVertex") ;
	setProperty("name", "rv_"+str.setNum(id_++)) ;
}

QRegionVertex::QRegionVertex(QPoint3f * p) : QPoint3f(p->x(), p->y(), 0.0) 
{
	QString str ;
	setProperty("type", "RegionVertex") ;
	setProperty("name", "rv_"+str.setNum(id_++)) ;
}

void QRegionVertex::addEdge(QRegionEdge * e)
{
	incident_edges_ << e ;
}

QList<QRegionEdge *> QRegionVertex::edges(void)
{
	return incident_edges_ ;
}

bool QRegionVertex::equals(QRegionVertex * other)
{
	return (x() == other->x() && y() == other->y()) ;
}

bool QRegionVertex::operator==(QRegionVertex & other)
{
	return (x() == other.x() && y() == other.y()) ;
}

bool QRegionVertex::operator==(QRegionVertex * other)
{
	return (x() == other->x() && y() == other->y()) ;
}

} ; // namespace QData
