/******************************************************************************
 * A x e l                                                                    *
 ******************************************************************************
 * QRegionVertex                                                              *
 * 2006-10-16                                                                 *
 * Julien Wintz                                                               *
 ******************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis                    *
 ******************************************************************************
 * Comments :                                                                 *
 ******************************************************************************/

# ifndef QREGIONVERTEX_H
# define QREGIONVERTEX_H

# include <QList>
# include <QString>

# include <QAxel/QPoint3f.h>

using namespace QAxel ;

namespace QData {

class QRegionEdge ;

/****************************************************************************/
/*!
  \class QRegionVertex QRegionVertex.h
  \brief The class QRegionVertex provides ...

  More ...
*/
/****************************************************************************/
class QRegionVertex : public QPoint3f
{
public :
	QRegionVertex(float x, float y) ;
	QRegionVertex(QPoint3f * p) ;
	void addEdge(QRegionEdge * e) ;
	QList<QRegionEdge *> edges(void) ;
	
	bool equals(QRegionVertex * other) ;
	
	bool operator==(QRegionVertex & other) ;
	bool operator==(QRegionVertex * other) ;
	
private:
	QList<QRegionEdge *> incident_edges_ ;
	
private:
	static int id_ ;
} ;

} // namespace QData

# endif // QREGIONVERTEX_H
