/*****************************************************************************
 * A x e l
 *****************************************************************************
 * ManipulatedFrameSetConstraint.h
 * 2006-03-05
 * Julien Wintz
 *****************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :
 ****************************************************************************/

# ifndef MANIPULATEDFRAMESETCONSTRAINT_H
# define MANIPULATEDFRAMESETCONSTRAINT_H

# include <QGLViewer/constraint.h>
# include <QAxel/QAxelObject.h>

class ManipulatedFrameSetConstraint : public qglviewer::Constraint 
{
public:
  void clearSet();
  void addObjectToSet(QAxel::QAxelObject* o);

  virtual void constrainTranslation(qglviewer::Vec &translation, qglviewer::Frame *const frame);
  virtual void constrainRotation(qglviewer::Quaternion &rotation, qglviewer::Frame *const frame);

private :
  QList<QAxel::QAxelObject*> objects_;
} ;

# endif // MANIPULATEDFRAMESETCONSTRAINT_H
