/*****************************************************************************
 * A x e l
 *****************************************************************************
 * ObjectToolDock
 * 2006-09-28
 * Julien Wintz
 *****************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :
 *
 ****************************************************************************/
  
# ifndef OBJECTTOOLDOCK_H
# define OBJECTTOOLDOCK_H

# include <QDockWidget>

class QTreeWidget ;
class QTreeWidgetItem ;

class ObjectToolDock : public QDockWidget {
	Q_OBJECT       

public :
	ObjectToolDock(const QString & title, QWidget * parent) ;

	//************** AF SandBox
	int getSelectedObjectType(void);
	//*************************
	
signals :
	void pointClicked(void) ;
	void planeClicked(void) ;
	void curveClicked(void) ;
	void surfaceClicked(void) ;
	
	void icIntersectionClicked(void) ;
	void pcIntersectionClicked(void) ;
	void isIntersectionClicked(void) ;
	void psIntersectionClicked(void) ;

	void bscInterpolationClicked(void) ;
	void bscApproximationClicked(void) ;
	void bssApproximationClicked(void) ;
        void bscJoinClicked(void) ;
    
	
	void bunionClicked(void) ;
	void bintersectionClicked(void) ;
	void bdifferenceClicked(void) ;
	void curvesArrangementClicked(void) ;
	void surfacesArrangementClicked(void) ;
	
	void criticalPointsClicked(void) ;
	void firstDerivativeClicked(void) ;
	void secondDerivativeClicked(void) ;
	void jacobiCurveClicked(void) ;
	void hessianCurveClicked(void) ;
	void graphedSurfaceClicked(void) ;
	
	void incidenceConstraintClicked(void) ;
	void distanceConstraintClicked(void) ;
	void angleConstraintClicked(void) ;

private slots :
	void expandItem(QTreeWidgetItem * item) ;
	void emmitSignals(QTreeWidgetItem * item) ;

private :
	QTreeWidget * tree ;                       
	
	QTreeWidgetItem * objects ;   
	QTreeWidgetItem * point ;
	QTreeWidgetItem * plane ;
	QTreeWidgetItem * curve ;
	QTreeWidgetItem * surface ;
	
	QTreeWidgetItem * intersections ;
	QTreeWidgetItem * pcintersection ;
	QTreeWidgetItem * icintersection ;
	QTreeWidgetItem * psintersection ;
	QTreeWidgetItem * isintersection ;
	
	QTreeWidgetItem * interpolations ;
        QTreeWidgetItem * approximations ;
        QTreeWidgetItem * joins ;
	QTreeWidgetItem * bscinterpolation ;
        QTreeWidgetItem * bscapproximation ;
        QTreeWidgetItem * bssapproximation ;
        QTreeWidgetItem * bscjoin ;
    
	
	QTreeWidgetItem * settheoretic ;
	QTreeWidgetItem * bunion ;  
	QTreeWidgetItem * bintersection ;
	QTreeWidgetItem * bdifference ;
	QTreeWidgetItem * arrangements ;
	QTreeWidgetItem * curves_arrangement ;
	QTreeWidgetItem * surfaces_arrangement ;
	
	QTreeWidgetItem * differential_calculus ;
	QTreeWidgetItem * critical_points ;
	QTreeWidgetItem * first_derivative_curve ;
	QTreeWidgetItem * second_derivative_curve ;
	QTreeWidgetItem * jacobi_curve ;
	QTreeWidgetItem * hessian_curve ;
	QTreeWidgetItem * graphed_surface ;
	
	QTreeWidgetItem * constraints ;
	QTreeWidgetItem * incidenceConstraint ;
	QTreeWidgetItem * distanceConstraint ;
	QTreeWidgetItem * angleConstraint ;
} ;

# endif
