/*****************************************************************************
 * Axel
 *****************************************************************************
 * QAlgorithmWidget
 * 2007-5-31
 * Ashish Reddy
 *****************************************************************************
 *               Copyright (C) 2006-2007 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :
 *
 ****************************************************************************/

# include <QLabel>
# include <QString>
# include <QHBoxLayout>
# include <QPixmap>

# include <QGui/QAlgorithmWidget.h> 

QAlgorithmWidget::QAlgorithmWidget(QWidget* parent) : QWidget(parent)
{
    layout = new QHBoxLayout(this) ;
    layout->setSpacing(2);
    layout->setMargin(0);
    setLayout(layout) ;
}

void QAlgorithmWidget::addElement(QString name, QString pixmap, QString tooltip) 
{
    if(w_widgets.keys().contains(name)) {
	qDebug("widget already exists") ;
	return ;
    }
    
    QLabel * l = new QLabel("", this) ;
    l->setPixmap(QPixmap(pixmap)) ;
    l->setToolTip(tooltip) ;
    w_widgets.insert(name, l) ;
    layout->addWidget(l) ;
}

void QAlgorithmWidget::setToolTip(QString name, QString tooltip) 
{
    w_widgets.value(name)->setToolTip(tooltip) ;
}

void QAlgorithmWidget::setPixmap(QString name, QString pixmap)
{
    w_widgets.value(name)->setPixmap(QPixmap(pixmap)) ;
}

void QAlgorithmWidget::removeElement(QString name) 
{
    if(!w_widgets.keys().contains(name))
	qDebug("no such widget added");
    QLabel * label = w_widgets.value(name);
    layout->removeWidget(w_widgets.value(name)) ;
    w_widgets.remove(name) ;
    delete label;
}
