/*****************************************************************************
 * Axel
 *****************************************************************************
 * QAlgorithmWidget
 * 2007-5-31
 * Ashish Reddy
 *****************************************************************************
 *               Copyright (C) 2006-2007 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :
 *
 ****************************************************************************/

# ifndef QALGORITHMWIDGET_H
# define QALGORITHMWIDGET_H

# include <QObject>
# include <QWidget>
# include <QMap>

class QLabel ;
class QPixmap ;
class QHBoxLayout ;

/****************************************************************************/
/*!
  \class QAlgorithmWidget QAlgorithmWidget.h
  \brief The class QAlgorithmWidget provide a way to display running 
  algorithms.

  Each algorithms is in charge to hardcode an identifier referred to as 
  \param name. This identifier allows to create, modify and delete the
  associated widget.

  Warning: the identifier should be unique.
*/
/****************************************************************************/

class QAlgorithmWidget : public QWidget
{
    Q_OBJECT

public:
    QAlgorithmWidget(QWidget * parent);

public slots:
    void addElement(QString name, QString pixmap, QString tooltip) ;
    void removeElement(QString name) ;
    void setToolTip(QString name, QString tooltip) ;
    void setPixmap(QString name, QString pixmap) ;

private:
    QMap<QString, QLabel *> w_widgets ;
    QHBoxLayout * layout ;

} ;

#endif
