/*****************************************************************************
 * Axel
 *****************************************************************************
 * QCameraModeWidget
 * 2007-5-25
 * Ashish Reddy
 *****************************************************************************
 *               Copyright (C) 2006-2007 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :
 *
 ****************************************************************************/


# include <QLabel>
# include <QPixmap>
# include <QString>
# include <QHBoxLayout>
 
# include <QGui/QCameraModeWidget.h>

QCameraModeWidget::QCameraModeWidget(QWidget * parent) : QWidget(parent)
{
    mode = new QLabel("...", this) ;

    pixmap = new QLabel("", this) ;
    pixmap->setToolTip("Perspective Mode") ; 
    setPixmap(":images/objects/perspective.png") ;

    layout = new QHBoxLayout(this) ;
    layout->addWidget(pixmap) ;
    layout->addWidget(mode) ;
    layout->setSpacing(2);
    layout->setMargin(0);

    setLayout(layout) ;
}
 
void QCameraModeWidget::setText(QString s)
{
    mode->setText(s) ;
    if(s == " Perspective ") {
	setPixmap(":images/objects/perspective.png");
	pixmap->setToolTip("Perspective Mode");
    }
    if(s == " Orthographic ") {
	setPixmap(":images/objects/orthographic.png");
	pixmap->setToolTip("Orthographic Mode");
    }
}
    
void QCameraModeWidget::setPixmap(QString resourceName)
{
    pixmap->setPixmap(QPixmap(resourceName)) ;
}
 
