/*****************************************************************************
 * Axel
 *****************************************************************************
 * QDimensionModeWidget
 * 2007-5-25
 * Ashish Reddy
 *****************************************************************************
 *               Copyright (C) 2006-2007 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :
 *
 ****************************************************************************/


# include <QLabel>
# include <QPixmap>
# include <QString>
# include <QHBoxLayout>

# include <QGui/QDimensionModeWidget.h>

QDimensionModeWidget::QDimensionModeWidget(QWidget * parent) : QWidget(parent)
{
    mode = new QLabel(" 3D  ",this) ;

    pixmap = new QLabel("",this) ;
    setPixmap(":images/16x16/camera.png") ;
    pixmap->setToolTip("3 Dimension Modeling Mode") ;

    layout = new QHBoxLayout(this) ;
    layout->addWidget(pixmap) ;
    layout->addWidget(mode) ;
    layout->setSpacing(2) ;
    layout->setMargin(0) ;
    setLayout(layout) ;

}

void QDimensionModeWidget::setDimensionMode(QString dimMode)
{
    mode->setText(dimMode) ;
    if(dimMode == " 2D  "){
	pixmap->setToolTip("2 Dimension Modeling Mode") ;
	emit dimensionModeSet(false);
    }
    if(dimMode == " 3D  "){
	pixmap->setToolTip("3 Dimension Modeling Mode") ;
	emit dimensionModeSet(true);
    }
}

void QDimensionModeWidget::setPixmap(QString resourceName)
{
    pixmap->setPixmap(QPixmap(resourceName));
}
    
