/*****************************************************************************
 * A x e l
 *****************************************************************************
 * QIntersection
 * 2007-02-24
 * Stephane Chau
 *****************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis
 *****************************************************************************/

# ifndef QINTERSECTION_H
# define QINTERSECTION_H

# include <QList>
# include <QString>

# include <QAxel/QAxelObject.h>
# include <QAxel/QPoint3f.h>

// # include <QData/QTreeNode4D.h>
// # include <QData/QHexatree.h>


class MainWindow;
class Viewer;

using namespace QAxel ;

namespace QIntersection {

// typedef QAxelObject Object_t ;
// typedef QPoint3f Point_t ;
// typedef QRegionVertex Vertex_t ;
// typedef QRegionEdge Edge_t ;
// typedef QRegionFace Face_t ;
// typedef QRegion3f Region_t ;
// typedef QCell Cell_t ;
// typedef Node<Cell_t *> Node_t ;
// typedef Octree<Cell_t *> Octree_t ;
// typedef QGraph Graph_t ;
// typedef QGraphNode GraphNode_t ;

/****************************************************************************/
/*!
  \class QIntersection QIntersection.h
  \brief The class QIntersection is an abstract base class for intersection
  algorithms using a subdivision sheme.
*/
/****************************************************************************/
class QIntersection : public QObject
{
    Q_OBJECT
	
public:
    QIntersection(MainWindow * mw) ;
    ~QIntersection(void) ;
  
public slots:
    virtual void run(void) = 0 ;

protected:
	double sbd_epsilon;
	double sbd_epsilon_max;
// 
protected:
    MainWindow * mainwindow ;
    Viewer * viewer ;
} ;

} ; // namespace QIntersection ;

# endif // QINTERSECTION_H
