/******************************************************************************
 * A x e l                                                                    *
 ******************************************************************************
 * QPatch22Intersection                                                       *
 * 2007-03-07                                                                 *
 * Séphane CHAU                                                               *
 ******************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis                    *
 ******************************************************************************
 *                                                                            *
 ******************************************************************************/

# ifndef QPATCH22INTERSECTION_H
# define QPATCH22INTERSECTION_H

# include <QAxel/QSurface.h>
# include <QAxel/QCurve.h>
# include <QIntersection/Surfaces/QRationalSurfaceIntersection.h>

namespace QIntersection {

class QPatch22Intersection : public QRationalSurfaceIntersection
{
    Q_OBJECT

public:
    QPatch22Intersection(QRationalSurface * s1, QRationalSurface * s2, MainWindow * mw) ;
    ~QPatch22Intersection(void) ;
	
	// QImplicitCurve4D * getIntersectionCurve4D(void);
  
public slots:
    void run(void) ;

private:
	QImplicitCurve4D * curve ;
	QRationalSurface * s1 ;
	QRationalSurface * s2 ;
} ;

} ; // namespace QIntersection ;

# endif // QPATCH22INTERSECTION_H
