/*****************************************************************************
 * A x e l
 *****************************************************************************
 * QP5GlovePlugin
 * 2006-12-08
 * Julien Wintz
 *****************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :         
 *
 ****************************************************************************/

# ifndef QP5GLOVEPLUGIN_H
# define QP5GLOVEPLUGIN_H

# include <p5sdk.h>
# include <p5glove.h>
# include <estimator.h>

# include <QP5Glove/QP5GloveInterface.h>

class QP5GlovePlugin : public QObject, public QP5GloveInterface
{
    Q_OBJECT
    Q_INTERFACES(QP5GloveInterface QAxel::QPluginInterface QAxel::QInitializablePluginInterface)
	
public:
    QStringList features() const ;
    QString name() const;
    void init(MainWindow * window) ;
    void idle(void) ;
    void drawIRs(void) ;
    void end(void) ;

protected:
    void ProcessGloveInput() ;
    void GetGloveInput() ;
	
private:
    void InitPRFilters() ;
    void GetZeroPosition() ;
    
private:
    t_p5_vec3 cen, ypr, gpos, pos, zeropos, zerorot ;
    float glove_error ;
    float gl_rescale ;
    int use_abs_pos ;
    int finger_bend[5] ;
    
    CEstimator est_pos[3] ;
    CEstimator est_ypr[3] ;
    
# if defined(Q_WS_X11)
    P5Data p5data;
# else
    P5Glove glove ;
    struct p5glove_data info ;
    int sample ;
# endif
} ;

# endif
