/***************************************************************************
                          estimator.h  -  description
                             -------------------
    begin                : Thu Feb 27 2003
    copyright            : (C) 2003 by Silviu Simen
    email                : ssimen@vryad.com
 ***************************************************************************/
#ifndef _ESTIMATOR_H__
#define _ESTIMATOR_H__

class CEstimator
{

  float a, v, x;
  float *coefs;
  float *speeds;
  float *accs;
  int m_numfilled;
  int m_grade;
  float GetAverage (float *data, int size);
  float GetStdDeviation (float *data, int size, float average);
  float GetAverageWithStdDeviation (float *data, int size, float average, float stddev, int *numused);

public:
  CEstimator ();
  virtual ~ CEstimator ();
  float GetFilteredAvg (float *stddev, int *numused);
  float GetAverage ();

  void Init (int grade);
  void ZeroAll ();
  void Done ();
  void AddSample (float value);
  float GetEstimate ();
};

#endif 
