/*****************************************************************************
 * A x e l
 *****************************************************************************
 * OStreamSurf
 * 2007-02-07
 * Julien Wintz
 *****************************************************************************
 *               Copyright (C) 2006 INRIA Sophia-Antipolis
 *****************************************************************************
 * Comments :
 ****************************************************************************/

# ifndef OSTREAMSURF_H
# define OSTREAMSURF_H

# include <QAxel/QMesh.h>
# include <QStream/OStream/OStream.h>

using namespace QAxel ;

class Viewer;
class QProgressDialog;

namespace QStream {

class OStreamSurf : public OStream
{
public :
	OStreamSurf(QString s, Viewer * v) ;
	void run(void) ;

public slots:
	void setOutputWidth(int width) ;
	void setOutputHeight(int height) ;
	
private :
	void save(void);
	void setUpLights(void) ;
	void setUpImage(void) ;
	void setUpScene(void) ;
	void setUpOutput(void) ;

    QString filterEquation(QString equation) ;
    void getAngles(float m[3][3], float * rot_x, float * rot_y, float * rot_z) ;

private :
	Viewer * viewer;
	QString filename;
	QString content;
	QString num ;
	QProgressDialog * progress;
	
	int outputWidth ;
	int outputHeight ;
	
	QColor backgroundColor ;
	QColor surfaceOutsideColor ;
	QColor surfaceInsideColor ;
} ;

} ;

# endif
